Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -128,7 +128,6 @@
  * 4823:     function stepHeader()
  * 4865:     function note123()
  * 4879:     function endNotes()
- * 4898:     function convertByteSize($bytes)
  * 4912:     function securityRisk()
  * 4930:     function alterPasswordForm()
  * 4946:     function messageBasicFinished()
@@ -156,6 +155,7 @@
 require_once(t3lib_extMgm::extPath('install').'updates/class.tx_coreupdates_installnewsysexts.php');
 require_once(t3lib_extMgm::extPath('install') . 'mod/class.tx_install_session.php');
 require_once(t3lib_extMgm::extPath('install') . 'updates/class.tx_coreupdates_statictemplates.php');
+require_once(PATH_tslib . 'class.tslib_content.php');
 
 /**
  * Install Tool module
@@ -166,14 +166,21 @@
  * @subpackage tx_install
  */
 class tx_install extends t3lib_install {
+	var $contentObject;
+	var $templateFilePath = 'typo3/sysext/install/Resources/Private/Templates/';
+	var $template;
+	var $javascript;
+	var $stylesheets;
+	var $markers = array();
+	var $messages = array();
+	var $errorMessages = array();
+	var $mailMessage = '';
 	var $getGD_start_string='<h2 align="center"><a name="module_gd">gd</a></h2>';	// Used to identify the GD section in the output from phpinfo()
 	var $getGD_end_string = '</table>';	// Used to identify the end of the GD section (found with getGD_start_string) in the output from phpinfo()
 	var $getTTF_string = 'with TTF library';	// Used to identify whether TTF-lib is included with GD
 	var $getTTF_string_alt = 'with freetype';       // Used to identify whether TTF-lib is included with GD
 	var $action = '';		// The url that calls this script
 	var $scriptSelf = 'index.php';		// The url that calls this script
-	var $fontTag2='<div class="bodytext">';
-	var $fontTag1='<div class="smalltext">';
 	var $updateIdentity = 'TYPO3 Install Tool';
 	var $headerStyle ='';
 	var $contentBeforeTable='';
@@ -187,11 +194,11 @@
 	var $dumpImCommands=1;			// If set, the image Magick commands are always outputted in the image processing checker
 	var $mode = '';	// If set to "123" then only most vital information is displayed.
 	var $step = 0;	// If set to 1,2,3 or GO it signifies various functions.
+	var $totalSteps = 4; // Can be changed by hook to define the total steps in 123 mode
 
 	// internal
 	var $passwordOK=0;			// This is set, if the password check was ok. The function init() will exit if this is not set
 	var $silent=1;				// If set, the check routines don't add to the message-array
-	var $messageFunc_nl2br=1;
 	var $sections=array();		// Used to gather the message information.
 	var $fatalError=0;			// This is set if some error occured that will definitely prevent TYpo3 from running.
 	var $sendNoCacheHeaders=1;
@@ -240,14 +247,15 @@
 	/**
 	 * Constructor
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function tx_install()	{
+	function tx_install() {
 		parent::t3lib_install();
+		$this->contentObject = t3lib_div::makeInstance('tslib_cObj');
 
 		if (!$GLOBALS['TYPO3_CONF_VARS']['BE']['installToolPassword'])	die("Install Tool deactivated.<br />You must enable it by setting a password in typo3conf/localconf.php. If you insert the line below, the password will be 'joh316':<br /><br />\$TYPO3_CONF_VARS['BE']['installToolPassword'] = 'bacb98acf97e0b6112b1d1b650b84971';");
 
-		if ($this->sendNoCacheHeaders)	{
+		if ($this->sendNoCacheHeaders) {
 			header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
 			header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
 			header('Expires: 0');
@@ -282,11 +290,19 @@
 			}
 		}
 
-		if ($this->step == 3) {
+		if ($this->step == 4) {
 			$this->INSTALL['type'] = 'database';
 		}
 
-		if ($this->mode=='123')	{
+			// Hook to raise the counter for the total steps in the 1-2-3 installer
+		if (is_array ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install/mod/class.tx_install.php']['additionalSteps'])) {
+			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install/mod/class.tx_install.php']['additionalSteps'] as $classData) {
+				$hookObject = t3lib_div::getUserObj($classData);
+				$this->totalSteps += (integer) $hookObject->execute();
+			}
+		}
+
+		if ($this->mode=='123') {
 			$tempItems = $this->menuitems;
 			$this->menuitems = array(
 				'config' => $tempItems['config'],
@@ -331,7 +347,7 @@
 ';
 		}
 
-		if ($this->session->isAuthorized() || $this->checkPassword())	{
+		if ($this->session->isAuthorized() || $this->checkPassword()) {
 			$this->passwordOK=1;
 			$this->session->refreshSession();
 
@@ -341,7 +357,7 @@
 				@touch($enableInstallToolFile);
 			}
 
-			if($this->redirect_url)	{
+			if($this->redirect_url) {
 				t3lib_utility_Http::redirect($this->redirect_url);
 			}
 		} else {
@@ -360,12 +376,12 @@
 	function checkPassword() {
 		$p = t3lib_div::_GP('password');
 
-		if ($p && md5($p)==$GLOBALS['TYPO3_CONF_VARS']['BE']['installToolPassword'])	{
+		if ($p && md5($p)==$GLOBALS['TYPO3_CONF_VARS']['BE']['installToolPassword']) {
 			$this->session->setAuthorized();
 
 				// Sending warning email
 			$wEmail = $GLOBALS['TYPO3_CONF_VARS']['BE']['warning_email_addr'];
-			if ($wEmail)	{
+			if ($wEmail) {
 				$subject="Install Tool Login at '".$GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename']."'";
 				$email_body="There has been a Install Tool login at TYPO3 site '".$GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename']."' (".t3lib_div::getIndpEnv('HTTP_HOST').") from remote address '".t3lib_div::getIndpEnv('REMOTE_ADDR')."' (".t3lib_div::getIndpEnv('REMOTE_HOST').')';
 				mail($wEmail,
@@ -377,9 +393,9 @@
 			return true;
 		} else {
 				// Bad password, send warning:
-			if ($p)	{
+			if ($p) {
 				$wEmail = $GLOBALS['TYPO3_CONF_VARS']['BE']['warning_email_addr'];
-				if ($wEmail)	{
+				if ($wEmail) {
 					$subject="Install Tool Login ATTEMPT at '".$GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename']."'";
 					$email_body="There has been an Install Tool login attempt at TYPO3 site '".$GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename']."' (".t3lib_div::getIndpEnv('HTTP_HOST').").
 The MD5 hash of the last 5 characters of the password tried was '".substr(md5($p), -5)."'
@@ -396,62 +412,142 @@
 	}
 
 	/**
-	 * [Describe function...]
+	 * Create the HTML for the login form
 	 *
-	 * @return	[type]		...
+	 * Reads and fills the template.
+	 * Substitutes subparts when wrong password has been given
+	 * or the session has expired
+	 *
+	 * @return void
 	 */
-	function loginForm()	{
-		$p = t3lib_div::_GP('password');
+	function loginForm() {
+		$password = t3lib_div::_GP('password');
 		$redirect_url = $this->redirect_url ? $this->redirect_url : $this->action;
-
-		$this->messageFunc_nl2br=0;
-		$this->silent=0;
-
-		$content = '<form action="index.php" method="post" name="passwordForm">
-			<input type="password" name="password"><br />
-			<input type="hidden" name="redirect_url" value="'.htmlspecialchars($redirect_url).'">
-			<input type="submit" value="Log in"><br />
-			<br />
-
-			'.$this->fw('The Install Tool Password is <i>not</i> the admin password of TYPO3.<br />
-				If you don\'t know the current password, you can set a new one by setting the value of $TYPO3_CONF_VARS[\'BE\'][\'installToolPassword\'] in typo3conf/localconf.php to the md5() hash value of the password you desire.'.
-				($p ? '<br /><br />The password you just tried has this md5-value: <br /><br />'.md5($p) : '')
-				).'
-			</form>
-			<script type="text/javascript">
-			<!--
-				document.passwordForm.password.focus();
-			//-->
-			</script>';
-
+			// Add prototype to javascript array for output
+		$this->javascript[] = '<script type="text/javascript" src="' .
+			t3lib_div::getIndpEnv('TYPO3_SITE_URL') .
+			TYPO3_mainDir .
+			'contrib/prototype/prototype.js"></script>
+		';
+			// Get the template file
+		$templateFile = @file_get_contents(
+			PATH_site . $this->templateFilePath . 'LoginForm.html'
+		);
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart(
+			$templateFile, '###TEMPLATE###'
+		);
+			// Password has been given, but this form is rendered again.
+			// This means the given password was wrong
+		if (!empty($password)) {
+				// Get the subpart for the wrong password
+			$wrongPasswordSubPart = $this->contentObject->getSubpart(
+				$template, '###WRONGPASSWORD###'
+			);
+				// Define the markers content
+			$wrongPasswordMarkers = array(
+				'passwordMessage' => 'The password you just tried has this md5-value:',
+				'password' => md5($password)
+			);
+				// Fill the markers in the subpart
+			$wrongPasswordSubPart = $this->contentObject->substituteMarkerArray(
+				$wrongPasswordSubPart,
+				$wrongPasswordMarkers,
+				'###|###',
+				1,
+				1
+			);
+		}
+			// Session has expired
 		if (!$this->session->isAuthorized() && $this->session->isExpired()) {
-			$this->message('Password', 'Your install tool session has expired', '', 3);
+				// Get the subpart for the expired session message
+			$sessionExpiredSubPart = $this->contentObject->getSubpart(
+				$template, '###SESSIONEXPIRED###'
+			);
+				// Define the markers content
+			$sessionExpiredMarkers = array(
+				'message' => 'Your install tool session has expired'
+			);
+				// Fill the markers in the subpart
+			$sessionExpiredSubPart = $this->contentObject->substituteMarkerArray(
+				$sessionExpiredSubPart,
+				$sessionExpiredMarkers,
+				'###|###',
+				1,
+				1
+			);
 		}
-		$this->message('Password', 'Enter the Install Tool Password', $content, 0);
-		$this->output($this->outputWrapper($this->printAll()));
+			// Substitute the subpart for the expired session in the template
+		$template = $this->contentObject->substituteSubpart(
+			$template,
+			'###SESSIONEXPIRED###',
+			$sessionExpiredSubPart
+		);
+			// Substitute the subpart for the wrong password in the template
+		$template = $this->contentObject->substituteSubpart(
+			$template,
+			'###WRONGPASSWORD###',
+			$wrongPasswordSubPart
+		);
+			// Define the markers content
+		$markers = array(
+			'siteName' => 'Site: ' .
+				$GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename'],
+			'headTitle' => 'Login to TYPO3 ' . TYPO3_version . ' Install tool',
+			'redirectUrl' => htmlspecialchars($redirect_url),
+			'enterPassword' => 'Password',
+			'login' => 'Login',
+			'message' => '
+				<p class="typo3-message message-information">
+					The Install Tool Password is <em>not</em> the admin password
+					of TYPO3.
+					<br />
+					If you don\'t know the current password, you can set a new
+					one by setting the value of
+					$TYPO3_CONF_VARS[\'BE\'][\'installToolPassword\'] in
+					typo3conf/localconf.php to the md5() hash value of the
+					password you desire.
+				</p>
+			'
+		);
+			// Fill the markers in the template
+		$content = $this->contentObject->substituteMarkerArray(
+			$template,
+			$markers,
+			'###|###',
+			1,
+			1
+		);
+			// Send content to the page wrapper function
+		$this->output($this->outputWrapper($content));
 	}
 
 	/**
-	 * Calling function that checks system, IM, GD, dirs, database and lets you alter localconf.php
+	 * Calling function that checks system, IM, GD, dirs, database
+	 * and lets you alter localconf.php
+	 *
 	 * This method is called from init.php to start the install Tool.
 	 *
-	 * @return	void
+	 * @return void
 	 */
-	function init()	{
-		if (!defined('PATH_typo3'))	exit;		// Must be called after inclusion of init.php (or from init.php)
+	function init() {
+		// Must be called after inclusion of init.php (or from init.php)
+		if (!defined('PATH_typo3'))	exit;
 		if (!$this->passwordOK)	exit;
 
 			// Setting stuff...
 		$this->check_mail();
 		$this->setupGeneral();
 		$this->generateConfigForm();
-		if (count($this->messages))	t3lib_div::debug($this->messages);
+		if (count($this->messages)) {
+			t3lib_div::debug($this->messages);
+		}
 
-		if ($this->step)	{
+		if ($this->step) {
 			$this->output($this->outputWrapper($this->stepOutput()));
 		} else {
 				// Menu...
-			switch($this->INSTALL['type'])	{
+			switch($this->INSTALL['type']) {
 				case 'images':
 					$this->checkIM=1;
 					$this->checkTheConfig();
@@ -471,58 +567,162 @@
 				case 'config':
 					$this->silent=0;
 					$this->checkIM=1;
-					$this->message('About configuration','How to configure TYPO3',$this->generallyAboutConfiguration());
+					$this->message(
+						'About configuration',
+						'How to configure TYPO3',
+						$this->generallyAboutConfiguration()
+					);
+					$this->message(
+						'System Information',
+						'Your system has the following configuration',
+						'
+							<dl id="systemInformation">
+								<dt>OS detected:</dt>
+								<dd>' . (TYPO3_OS == 'WIN' ? 'WIN' : 'UNIX') .'</dd>
+								<dt>UNIX/CGI detected:</dt>
+								<dd>' . (PHP_SAPI == 'cgi' ? 'YES' : 'NO') . '</dd>
+								<dt>PATH_thisScript:</dt>
+								<dd>' . PATH_thisScript . '</dd>
+							</dl>
+						'
+					);
 					$this->checkTheConfig();
 
 					$ext = 'Write config to localconf.php';
-					if ($this->fatalError)	{
-						if ($this->config_array['no_database'] || !$this->config_array['mysqlConnect'])	{
+					if ($this->fatalError) {
+						if (
+							$this->config_array['no_database'] ||
+							!$this->config_array['mysqlConnect']
+						) {
 							$this->message($ext, 'Database not configured yet!', '
-								You need to specify database username, password and host as one of the first things.
-								Next you\'ll have to select a database to use with TYPO3.
-								Use the form below:
-							',2);
+								<p>
+									You need to specify database username,
+									password and host as one of the first things.
+									<br />
+									Next you\'ll have to select a database to
+									use with TYPO3.
+								</p>
+								<p>
+									Use the form below.
+								</p>
+							', 2);
 						} else {
 							$this->message($ext, 'Fatal error encountered!', '
-								Somewhere above a fatal configuration problem is encountered. Please make sure that you\'ve fixed this error before you submit the configuration. TYPO3 will not run if this problem is not fixed!
-								You should also check all warnings that may appear.
-							',2);
+								<p>
+									Somewhere above a fatal configuration
+									problem is encountered.
+									Please make sure that you\'ve fixed this
+									error before you submit the configuration.
+									TYPO3 will not run if this problem is not
+									fixed!
+									<br />
+									You should also check all warnings that may
+									appear.
+								</p>
+							', 2);
 						}
 					} elseif ($this->mode=='123') {
-						if (!$this->fatalError)	{
+						if (!$this->fatalError) {
 							$this->message($ext, 'Basic configuration completed', '
-								You have no fatal errors in your basic configuration. You may have warnings though. Please pay attention to them! However you may continue and install the database.
-
-								<strong><span style="color:#f00;">Step 2:</span></strong> <a href="'.$this->scriptSelf.'?TYPO3_INSTALL[type]=database'.($this->mode?'&mode='.rawurlencode($this->mode):'').'">Click here to install the database.</a>
-							',-1,1);
+								<p>
+									You have no fatal errors in your basic
+									configuration.
+									You may have warnings though. Please pay
+									attention to them!
+									However you may continue and install the
+									database.
+								</p>
+								<p>
+									<strong>
+										<span style="color:#f00;">Step 2: </span>
+									</strong>
+									<a href="' . $this->scriptSelf .
+									'?TYPO3_INSTALL[type]=database' .
+									($this->mode ? '&mode=' . rawurlencode($this->mode) : '') .
+									'">Click here to install the database.</a>
+								</p>
+							', -1, 1);
 						}
 					}
-					$this->message($ext, 'Very Important: Changing Image Processing settings', "
-						When you change the settings for Image Processing you <i>must</i> take into account that <u>old images</u> may still be in typo3temp/ folder and prevent new files from being generated! This is especially important to know, if you're trying to set up image processing for the very first time.
-						The problem is solved by <a href=\"".htmlspecialchars($this->setScriptName('typo3temp'))."\">clearing the typo3temp/ folder</a>. Also make sure to clear the cache_pages table.
-						",1,1);
-					$this->message($ext, 'Very Important: Changing Encryption Key setting', "
-						When you change the setting for the Encryption Key you <i>must</i> take into account that a change to this value might invalidate temporary information, URLs etc.
-						The problem is solved by <a href=\"".htmlspecialchars($this->setScriptName('typo3temp'))."\">clearing the typo3temp/ folder</a>. Also make sure to clear the cache_pages table.
-						",1,1);
-					$this->message($ext, 'Update localconf.php', "
-						This form updates the localconf.php file with the suggested values you see below. The values are based on the analysis above.
-						You can change the values in case you have alternatives to the suggested defaults.
-						By this final step you will configure TYPO3 for immediate use provided that you have no fatal errors left above."
-						.$this->setupGeneral('get_form'),0,1);
+					$this->message($ext, 'Very Important: Changing Image Processing settings', '
+						<p>
+							When you change the settings for Image Processing
+							you <em>must</em> take into account
+							that <em>old images</em> may still be in typo3temp/
+							folder and prevent new files from being generated!
+							<br />
+							This is especially important to know, if you\'re
+							trying to set up image processing for the very first
+							time.
+							<br />
+							The problem is solved by <a href="' .
+							htmlspecialchars($this->setScriptName('typo3temp')) .
+							'">clearing the typo3temp/ folder</a>.
+							Also make sure to clear the cache_pages table.
+						</p>
+					', 1, 1);
+					$this->message($ext, 'Very Important: Changing Encryption Key setting', '
+						<p>
+							When you change the setting for the Encryption Key
+							you <em>must</em> take into account that a change to
+							this value might invalidate temporary information,
+							URLs etc.
+							<br />
+							The problem is solved by <a href="' .
+							htmlspecialchars($this->setScriptName('typo3temp')) .
+							'">clearing the typo3temp/ folder</a>.
+							Also make sure to clear the cache_pages table.
+						</p>
+					', 1, 1);
+					$this->message($ext, 'Update localconf.php', '
+						<p>
+							This form updates the localconf.php file with the
+							suggested values you see below. The values are based
+							on the analysis above.
+							<br />
+							You can change the values in case you have
+							alternatives to the suggested defaults.
+							<br />
+							By this final step you will configure TYPO3 for
+							immediate use provided that you have no fatal errors
+							left above.
+						</p>' . $this->setupGeneral('get_form') . '
+					', 0, 1);
 
 					$this->output($this->outputWrapper($this->printAll()));
 
 				break;
 				case 'extConfig':
 					$this->silent=0;
-
 					$this->generateConfigForm('get_form');
-
-					$content = $this->printAll();
-					$content = '<form action="'.$this->action.'" method="post">'.$content.'<input type="submit" value="Write to localconf.php"><br /><br />
-					'.$this->fw('<strong>NOTICE: </strong>By clicking this button, localconf.php is updated with new values for the parameters listed above!<br />').'
-					</form>';
+						// Get the template file
+					$templateFile = @file_get_contents(
+						PATH_site . $this->templateFilePath . 'InitExtConfig.html'
+					);
+						// Get the template part from the file
+					$template = $this->contentObject->getSubpart(
+						$templateFile, '###TEMPLATE###'
+					);
+						// Define the markers content
+					$markers = array(
+						'action' => $this->action,
+						'content' => $this->printAll(),
+						'write' => 'Write to localconf.php',
+						'notice' => 'NOTICE:',
+						'explanation' => '
+							By clicking this button, localconf.php is updated
+							with new values for the parameters listed above!
+						'
+					);
+						// Fill the markers in the template
+					$content = $this->contentObject->substituteMarkerArray(
+						$template,
+						$markers,
+						'###|###',
+						1,
+						1
+					);
+						// Send content to the page wrapper function
 					$this->output($this->outputWrapper($content));
 				break;
 				case 'typo3temp':
@@ -548,60 +748,152 @@
 					$this->silent=0;
 					$this->message('About', 'Warning - very important!', $this->securityRisk().$this->alterPasswordForm(),2);
 
-					$this->message('About', 'Using this script', "
-					Installing TYPO3 has always been a hot topic on the mailing list and forums. Therefore we've developed this tool which will help you through configuration and testing.
-					There are three primary steps for you to take:
+					$this->message('About', 'Using this script', '
+						<p>
+							Installing TYPO3 has always been a hot topic on the
+							mailing list and forums. Therefore we\'ve developed
+							this tool which will help you through configuration
+							and testing.
+							<br />
+							There are three primary steps for you to take:
+						</p>
+						<p>
+							<strong>1: Basic Configuration</strong>
+							<br />
+							In this step your PHP-configuration is checked. If
+							there are any settings that will prevent TYPO3 from
+							running correctly you\'ll get warnings and errors
+							with a description of the problem.
+							<br />
+							You\'ll have to enter a database username, password
+							and hostname. Then you can choose to create a new
+							database or select an existing one.
+							<br />
+							Finally the image processing settings are entered
+							and verified and you can choose to let the script
+							update the configuration file,
+							typo3conf/localconf.php with the suggested settings.
+						</p>
+						<p>
+							<strong>2: Database Analyser</strong>
+							<br />
+							In this step you can either install a new database
+							or update the database from any previous TYPO3
+							version.
+							<br />
+							You can also get an overview of extra/missing
+							fields/tables in the database compared to a raw
+							sql-file.
+							<br />
+							The database is also verified against your
+							\'tables.php\' configuration ($TCA) and you can
+							even see suggestions to entries in $TCA or new
+							fields in the database.
+						</p>
+						<p>
+							<strong>3: Update Wizard</strong>
+							<br />
+							Here you will find update methods taking care of
+							changes to the TYPO3 core which are not backwards
+							compatible.
+							<br />
+							It is recommended to run this wizard after every
+							update to make sure everything will still work
+							flawlessly.
+						</p>
+						<p>
+							<strong>4: Image Processing</strong>
+							<br />
+							This step is a visual guide to verify your
+							configuration of the image processing software.
+							<br />
+							You\'ll be presented to a list of images that should
+							all match in pairs. If some irregularity appears,
+							you\'ll get a warning. Thus you\'re able to track an
+							error before you\'ll discover it on your website.
+						</p>
+						<p>
+							<strong>5: All Configuration</strong>
+							<br />
+							This gives you access to any of the configuration
+							options in the TYPO3_CONF_VARS array. Every option
+							is also presented with a comment explaining what it
+							does.
+						</p>
+						<p>
+							<strong>6: typo3temp/</strong>
+							<br />
+							Here you can manage the files in typo3temp/ folder
+							in a simple manner. typo3temp/ contains temporary
+							files, which may still be used by the website, but
+							some may not. By searching for files with old
+							access-dates, you can possibly manage to delete
+							unused files rather than files still used. However
+							if you delete a temporary file still in use, it\'s
+							just regenerated as long as you make sure to clear
+							the cache tables afterwards.
+						</p>
+					');
 
-					<strong>1: Basic Configuration</strong>
-					In this step your PHP-configuration is checked. If there are any settings that will prevent TYPO3 from running correctly you'll get warnings and errors with a description of the problem.
-					You'll have to enter a database username, password and hostname. Then you can choose to create a new database or select an existing one.
-					Finally the image processing settings are entered and verified and you can choose to let the script update the configuration file, typo3conf/localconf.php with the suggested settings.
+					$this->message('About', 'Why is this script stand-alone?', '
+						<p>
+							You would think that this script should rather be a
+							module in the backend and access-controlled to only
+							admin-users from the database. But that\'s not how
+							it works.
+							<br />
+							The reason is, that this script must not be
+							depending on the success of the configuration of
+							TYPO3 and whether or not there is a working database
+							behind. Therefore the script is invoked from the
+							backend init.php file, which allows access if the
+							constant \'TYPO3_enterInstallScript\' has been
+							defined and is not false. That is and should be the
+							case <em>only</em> when calling the script
+							\'typo3/install/index.php\' - this script!
+						</p>
+					');
 
-					<strong>2: Database Analyser</strong>
-					In this step you can either install a new database or update the database from any previous TYPO3 version.
-					You can also get an overview of extra/missing fields/tables in the database compared to a raw sql-file.
-					The database is also verified agains your 'tables.php' configuration (\$TCA) and you can even see suggestions to entries in \$TCA or new fields in the database.
 
-					<strong>3: Update Wizard</strong>
-					Here you will find update methods taking care of changes to the TYPO3 core which are not backwards compatible.
-					It is recommended to run this wizard after every update to make sure everything will still work flawlessly.
-
-					<strong>4: Image Processing</strong>
-					This step is a visual guide to verify your configuration of the image processing software.
-					You'll be presented to a list of images that should all match in pairs. If some irregularity appears, you'll get a warning. Thus you're able to track an error before you'll discover it on your website.
-
-					<strong>5: All Configuration</strong>
-					This gives you access to any of the configuration options in the TYPO3_CONF_VARS array. Every option is also presented with a comment explaining what it does.
-
-					<strong>6: typo3temp/</strong>
-					Here you can manage the files in typo3temp/ folder in a simple manner. typo3temp/ contains temporary files, which may still be used by the website, but some may not. By searching for files with old access-dates, you can possibly manage to delete unused files rather than files still used. However if you delete a temporary file still in use, it's just regenerated as long as you make sure to clear the cache tables afterwards.
-					");
-
-					$this->message('About', 'Why is this script stand-alone?', "
-					You would think that this script should rather be a module in the backend and access-controlled to only admin-users from the database. But that's not how it works.
-					The reason is, that this script must not be depending on the success of the configuration of TYPO3 and whether or not there is a working database behind. Therefore the script is invoked from the backend init.php file, which allows access if the constant 'TYPO3_enterInstallScript' has been defined and is not false. That is and should be the case <i>only</i> when calling the script 'typo3/install/index.php' - this script!
-					");
-
-
 					$headCode='Header legend';
 					$this->message($headCode, 'Notice!', '
-					Indicates that something is important to be aware of.
-					This does <em>not</em> indicate an error.
-					',1);
+						<p>
+							Indicates that something is important to be aware
+							of.
+							<br />
+							This does <em>not</em> indicate an error.
+						</p>
+					', 1);
 					$this->message($headCode, 'Just information', '
-					This is a simple message with some information about something.
+						<p>
+							This is a simple message with some information about
+							something.
+						</p>
 					');
 					$this->message($headCode, 'Check was successful', '
-					Indicates that something was checked and returned an expected result.
-					',-1);
+						<p>
+							Indicates that something was checked and returned an
+							expected result.
+						</p>
+					', -1);
 					$this->message($headCode, 'Warning!', '
-					Indicates that something may very well cause trouble and you should definitely look into it before proceeding.
-					This indicates a <em>potential</em> error.
-					',2);
+						<p>
+							Indicates that something may very well cause trouble
+							and you should definitely look into it before
+							proceeding.
+							<br />
+							This indicates a <em>potential</em> error.
+						</p>
+					', 2);
 					$this->message($headCode, 'Error!', '
-					Indicates that something is definitely wrong and that TYPO3 will most likely not perform as expected if this problem is not solved.
-					This indicates an actual error.
-					',3);
+						<p>
+							Indicates that something is definitely wrong and
+							that TYPO3 will most likely not perform as expected
+							if this problem is not solved.
+							<br />
+							This indicates an actual error.
+						</p>
+					', 3);
 
 					$this->output($this->outputWrapper($this->printAll()));
 				break;
